// MorphingTestContainer.java
package morphingtool;

import java.awt.*;
import java.awt.geom.AffineTransform;
import javax.swing.*;

public class MorphingTestContainer extends JPanel {

  private Graphics2D angezeigteGrafik;
  private AffineTransform affineTransformation;
  protected int bildBreite,  bildHoehe;
  private int[] startDreieckX = new int[3];
  private int[] startDreieckY = new int[3];
  private int[] zielDreieckX = {61, 239, 161};
  private int[] zielDreieckY = {66, 66, 234};

  // Constructor wird als "Setter" Methode verwendet
  public MorphingTestContainer(int bildBreite, int bildHoehe, Point positionLinkesAuge,
    Point positionRechtesAuge, Point positionMund) {
    // Bildgrösse festlegen
    this.bildBreite = bildBreite;
    this.bildHoehe = bildHoehe;
    setPreferredSize(new Dimension(bildBreite, bildHoehe));
    // Setze Parameter
    startDreieckX[0] = positionLinkesAuge.x;
    startDreieckY[0] = positionLinkesAuge.y;
    startDreieckX[1] = positionRechtesAuge.x;
    startDreieckY[1] = positionRechtesAuge.y;
    startDreieckX[2] = positionMund.x;
    startDreieckY[2] = positionMund.y;
  }

  private void bildGenerieren() {
    // Zeichne grünes Zieldreieck
    angezeigteGrafik.setColor(Color.GREEN);
    angezeigteGrafik.fillPolygon(zielDreieckX, zielDreieckY, 3);
    // Zeichne rotes Startdreieck nach der Transformation
    angezeigteGrafik.setColor(Color.RED);
    angezeigteGrafik.setTransform(affineTransformation);
    angezeigteGrafik.fillPolygon(startDreieckX, startDreieckY, 3);
  }

  // Die Methode paintComponent wird von Java automatisch oder im Programm
  // über die Methode repaint() aufgerufen, um das Objekt grafik auf dem
  // Bildschirm darzustellen. 
  public void paintComponent(Graphics grafik) {
    // Zuerst wird die überschriebene original Methode aufgerufen
    super.paintComponent(grafik);
    // Java verwendet den alten Typ Graphics für das grafik Objekt. Um auf mehr
    // Methoden zugreifen zu können, casten wir den Typ auf Graphics2D
    angezeigteGrafik = (Graphics2D) grafik;
    // Hier wird alles Dazustellende hinzugefügt
    bildGenerieren();
  }

  void setAffineTransformation(AffineTransform affineTransformation) {
    this.affineTransformation = affineTransformation;
  }
}

