// MorphingTestContainer.java
package morphingtool;

import java.awt.*;
import javax.swing.*;

public class MorphingTestContainer extends JPanel {

  private Graphics2D angezeigteGrafik;
  protected int bildBreite,  bildHoehe;
  private int[] startDreieckX = new int[3];
  private int[] startDreieckY = new int[3];
  private int[] zielDreieckX = {61, 239, 161};
  private int[] zielDreieckY = {66, 66, 234};

  // Constructor wird als "Setter" Methode verwendet
  public MorphingTestContainer(int bildBreite, int bildHoehe, Point la, Point ra,
    Point m) {
    // Bildgrösse festlegen
    this.bildBreite = bildBreite;
    this.bildHoehe = bildHoehe;
    setPreferredSize(new Dimension(bildBreite, bildHoehe));
    // Setze Parameter
    startDreieckX[0] = la.x;
    startDreieckY[0] = la.y;
    startDreieckX[1] = ra.x;
    startDreieckY[1] = ra.y;
    startDreieckX[2] = m.x;
    startDreieckY[2] = m.y;
  }

  private void bildGenerieren() {
    // Zeichne grünes Zieldreieck
    angezeigteGrafik.setColor(Color.GREEN);
    angezeigteGrafik.fillPolygon(zielDreieckX, zielDreieckY, 3);
    // Zeichne rotes Startdreieck (nach der Transformation)
    angezeigteGrafik.setColor(Color.RED);
    angezeigteGrafik.fillPolygon(startDreieckX, startDreieckY, 3);
  }

  // Die Methode paintComponent wird von Java automatisch oder im Programm
  // über die Methode repaint() aufgerufen, um das Objekt grafik auf dem
  // Bildschirm darzustellen. 
  public void paintComponent(Graphics grafik) {
    // Zuerst wird die überschriebene original Methode aufgerufen
    super.paintComponent(grafik);
    // Java verwendet den alten Typ Graphics für das grafik Objekt. Um auf mehr
    // Methoden zugreifen zu können, casten wir den Typ auf Graphics2D
    angezeigteGrafik = (Graphics2D) grafik;
    // Hier wird alles Dazustellende hinzugefügt
    bildGenerieren();
  }
}

